//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vJAXB 2.1.10 in JDK 6 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2012.06.10 at 11:11:45 AM CEST 
//


package net.ihe.gazelle.cdagen.constraint.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import javax.persistence.UniqueConstraint;
import javax.validation.constraints.NotNull;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;

import org.jboss.seam.annotations.Name;


/**
 * <p>Java class for operation complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="operation"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="name" type="{http://www.w3.org/2001/XMLSchema}anyType"/&gt;
 *         &lt;element name="returnType" type="{http://www.w3.org/2001/XMLSchema}anyType"/&gt;
 *         &lt;sequence&gt;
 *           &lt;element name="parameters" type="{}parameter" maxOccurs="unbounded" minOccurs="0"/&gt;
 *         &lt;/sequence&gt;
 *       &lt;/sequence&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */

@Entity
@Name("operation")
@Table(name="cons_operation", schema="public", uniqueConstraints = @UniqueConstraint(columnNames = "id"))
@SequenceGenerator(name = "cons_operation_sequence", sequenceName = "cons_operation_id_seq", allocationSize=1)

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "operation", propOrder = {
		"id",
		"name",
		"returnType",
		"parameters"
})
public class Operation implements Serializable{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	@Id
	@NotNull
	@Column(name="id", nullable = false, unique = true)
	@GeneratedValue(strategy=GenerationType.SEQUENCE, generator="cons_operation_sequence")
	protected Integer id;

	@XmlElement(required = true)
	protected String name;

	@XmlElement(required = true)
	protected String returnType;

	@OneToMany(mappedBy = "operation", fetch = FetchType.LAZY)
	protected List<Parameter> parameters;

	@ManyToOne
	@JoinColumn(name = "classe_id")
	@XmlTransient
	protected Classe classe;

	public String getName() {
		return name;
	}

	public void setName(String value) {
		this.name = value;
	}

	public String getReturnType() {
		return returnType;
	}

	public void setReturnType(String value) {
		this.returnType = value;
	}

	public List<Parameter> getParameters() {
		if (parameters == null) {
			parameters = new ArrayList<>();
		}
		return this.parameters;
	}

	public Integer getId() {
		return id;
	}

	public void setId(Integer id) {
		this.id = id;
	}

	public Classe getClasse() {
		return classe;
	}

	public void setClasse(Classe classe) {
		this.classe = classe;
	}

	public void setParameters(List<Parameter> parameters) {
		this.parameters = parameters;
	}

}
